. '.\_Common_Initialize.ps1'

function Write-Passwords {
	param($Profile)

	for($i = 0; $i -lt 5; ++$i) {
		[KeePassLib.Security.ProtectedString]$ps = $null
		[KeePassLib.Cryptography.PasswordGenerator.PwGenerator]::Generate(
			[ref]$ps, $Profile, $null, $null) | Out-Null
		Write-Output $ps.ReadString()
	}
}

$pp = New-Object KeePassLib.Cryptography.PasswordGenerator.PwProfile

Write-Output '5 random passwords:'
Write-Passwords $pp

Write-Output ''

$pp = New-Object KeePassLib.Cryptography.PasswordGenerator.PwProfile
$pp.Length = 30
$pp.CharSet = New-Object KeePassLib.Cryptography.PasswordGenerator.PwCharSet @(
	'ABCDEFGHIJKLMNOPQRSTUVWXYZ' + 'abcdefghijklmnopqrstuvwxyz' +
	'0123456789' + '!"#$%&''()*+,-./:;<=>?@[\]^_`{|}~')

Write-Output '5 random passwords (length 30, with special characters):'
Write-Passwords $pp

Write-Output ''

$pp = New-Object KeePassLib.Cryptography.PasswordGenerator.PwProfile
$pp.GeneratorType = [KeePassLib.Cryptography.PasswordGenerator.PasswordGeneratorType]::Pattern
$pp.Pattern = 'H\2\-HH\-HH\-HH\-HH\-HH'

Write-Output '5 random MAC addresses:'
Write-Passwords $pp

. '.\_Common_Terminate.ps1'
